PUPPET-NODE(8)

NAME
puppet-node - View and manage node definitions.

SYNOPSIS
puppet node action [--terminus TERMINUS] [--extra HASH]

DESCRIPTION
This subcommand interacts with node objects, which are used by Puppet to build a catalog. A node object consists of the node's facts, environment, node parameters (exposed in the parser as top-scope variables), and classes.

OPTIONS
Note that any configuration parameter that's valid in the configuration file is also a valid long argument, although it may or may not be relevant to the present action. For example, server and run_mode are valid configuration parameters, so you can specify --server <servername>, or --run_mode <runmode> as an argument.

See the configuration file documentation at http://docs.puppetlabs.com/references/stable/configuration.html for the full list of acceptable parameters. A commented list of all configuration options can also be generated by running puppet with --genconfig.

--render-as FORMAT
    The format in which to render output. The most common formats are json, s (string), yaml, and console, but other options such as dot are sometimes available.

--verbose
    Whether to log verbosely.

--debug
    Whether to log debug information.

--extra HASH
    A terminus can take additional arguments to refine the operation, which are passed as an arbitrary hash to the back-end. Anything passed as the extra value is just send direct to the back-end.

--terminus TERMINUS
    Indirector faces expose indirected subsystems of Puppet. These subsystems are each able to retrieve and alter a specific type of data (with the familiar actions of find, search, save, and destroy) from an arbitrary number of pluggable backends. In Puppet parlance, these backends are called terminuses.

    Almost all indirected subsystems have a rest terminus that interacts with the puppet master's data. Most of them have additional terminuses for various local data models, which are in turn used by the indirected subsystem on the puppet master whenever it receives a remote request.

    The terminus for an action is often determined by context, but occasionally needs to be set explicitly. See the "Notes" section of this face's manpage for more details.

ACTIONS

clean - Clean up everything a puppetmaster knows about a node.
    SYNOPSIS

    puppet node clean [--terminus TERMINUS] [--extra HASH] [--[no-]unexport] host1 [host2 ...]

    DESCRIPTION

    Clean up everything a puppet master knows about a node, including certificates and storeconfigs data.

    The full list of info cleaned by this action is:

    Signed certificates - ($vardir/ssl/ca/signed/node.domain.pem)

    Cached facts - ($vardir/yaml/facts/node.domain.yaml)

    Cached node objects - ($vardir/yaml/node/node.domain.yaml)

    Reports - ($vardir/reports/node.domain)

    Stored configs - (in database) The clean action can either remove all data from a host in your storeconfigs database, or, with the --unexport option, turn every exported resource supporting ensure to absent so that any other host that collected those resources can remove them. Without unexporting, a removed node's exported resources become unmanaged by Puppet, and may linger as cruft unless you are purging that resource type.

    OPTIONS --[no-]unexport - Whether to remove this node's exported resources from other nodes

destroy - Invalid for this subcommand.
    SYNOPSIS

    puppet node destroy [--terminus TERMINUS] [--extra HASH] key

    DESCRIPTION

    Invalid for this subcommand.

find - Retrieve a node object.
    SYNOPSIS

    puppet node find [--terminus TERMINUS] [--extra HASH] host

    DESCRIPTION

    Retrieve a node object.

    RETURNS

    A hash containing the node's classes, environment, expiration, name, parameters (its facts, combined with any ENC-set parameters), and time. When used from the Ruby API: a Puppet::Node object.

    RENDERING ISSUES: Rendering as string and json are currently broken; node objects can only be rendered as yaml.

info - Print the default terminus class for this face.
    SYNOPSIS

    puppet node info [--terminus TERMINUS] [--extra HASH]

    DESCRIPTION

    Prints the default terminus class for this subcommand. Note that different run modes may have different default termini; when in doubt, specify the run mode with the '--run_mode' option.

save - Invalid for this subcommand.
    SYNOPSIS

    puppet node save [--terminus TERMINUS] [--extra HASH] key

    DESCRIPTION

    Invalid for this subcommand.

search - Invalid for this subcommand.
    SYNOPSIS

    puppet node search [--terminus TERMINUS] [--extra HASH] query

    DESCRIPTION

    Invalid for this subcommand.

EXAMPLES
find

Retrieve an "empty" (no classes, no ENC-imposed parameters, and an environment of "production") node:

$ puppet node find somenode.puppetlabs.lan --terminus plain --render-as yaml

Retrieve a node using the puppet master's configured ENC:

$ puppet node find somenode.puppetlabs.lan --terminus exec --run_mode master --render-as yaml

Retrieve the same node from the puppet master:

$ puppet node find somenode.puppetlabs.lan --terminus rest --render-as yaml

NOTES
This subcommand is an indirector face, which exposes find, search, save, and destroy actions for an indirected subsystem of Puppet. Valid termini for this face include:

•   active_record

•   exec

•   ldap

•   memory

•   plain

•   rest

•   store_configs

•   write_only_yaml

•   yaml

COPYRIGHT AND LICENSE
Copyright 2011 by Puppet Labs Apache 2 license; see COPYING